#include <stdio.h>
#include <string.h>
#include "fstor.hpp"

#define  SMART_POINTERS         // ᯮ㥬 㬭 㪠⥫
#define  NO_TEMPLATES           //  ᯮ㥬 蠡

#include "oodbs.hpp"

Dbs_Pointers_Declare( Record ); // । "㬭" 㪠⥫

class Record : public File_Object {   //    
  public:
    Record_Ptr  Next;           //   뢥  File_Object
    char        Text[ 1 ];
};

Dbs_Pointers_Define( Record );  // । ⮤ "㬭" 㪠⥫

Dbs_Channel DB_Vio   ( 10 ) ;   // ᮧ   /뢮
Dbs_Pool    DB_Cache ( 64 ) ;   // ᮧ  ࠭ (ࠧ஬ 64 ࠭)
Dbs_File    DB_File  ( "test2.dbs" );  // 䠩   ࠡ⠥  
Dbs_F_Store DB_Store ( DB_File , DB_Cache ); // ࠭  䠩
Dbs_Store*  DB_List = &DB_Store;    // ᯨ᮪ ࠭ ᯮ㥬  
Object_Database    Db( 1, &DB_List ); // ᮧ  



main () {
    Db.Open();  // 뢠  
    if( Db.Empty() )  { // ᫨  ,  㦭 ᮧ ୥ ꥪ
        Record_Tie  Rec;
	char Buf[ 256 ];
	while( fgets( Buf, sizeof Buf, stdin ) ) {
            Record_Tie New = new (strlen(Buf)) Record; // ᮧ  
            if( !Nil(Rec) ) Rec->Next = New;
            strcpy( New->Text, Buf );
            Rec = New;
        }
	if (!Nil(Rec)) { 
	    Rec->Next.Set_Nil();
	}
    } else { // ⮤ Start ୥ 㠫  ୥ ꥪ
        for( Record_Ptr Rec = Record_Ptr::Root(); !Nil(Rec); Rec = Rec->Next )
            fputs( Rec->Text, stdout );
    }
    Db.Close(); //     
    return 0;
}
