//-< PSTOR.HPP >-----------------------------------------------------*--------*
// GOODS                     Version 1.0          (c) 1992  GARRET   *     ?  *
// ( Garret object oriented data storage )                           *   /\|  *
// Fault protected storage                                           *  /  \  *
//                           Created:      04-Mar-92   K.A. Knizhnik * / [] \ *
//                           Last update:  26-May-94   K.A. Knizhnik * GARRET *
//-------------------------------------------------------------------*--------*

#ifndef  __PSTOR_HPP__
 #define  __PSTOR_HPP__

 #include "fstor.hpp"

 class Dbs_P_Store : public Dbs_F_Store {
   protected:
     Dbs_File*  Log;
     large      End;
     char*      Buf;

     void       Save( Dbs_Page* Pg );

   public:
     void       Flush();

     void       Open ( int Ident, Object_Database* Base );
     void       Close( void );

     Dbs_P_Store( Dbs_File& St_File, Dbs_Pool& St_Pool, Dbs_File& St_Log );
     virtual~Dbs_P_Store() { delete[] Buf; }
 };

#endif

