#include <stdio.h>
#include <string.h>
#include "fstor.hpp"

#define  SMART_POINTERS         // ᯮ㥬 㬭 㪠⥫

#include "oodbs.hpp"

struct Record : File_Object {   //    
    Ptr<Record> Next;           //   뢥  File_Object
    char        Text[ 1 ];
};

Dbs_Channel DB_Vio   ( 10 ) ;   // ᮧ   /뢮
Dbs_Pool    DB_Cache ( 64 ) ;   // ᮧ  ࠭ (ࠧ஬ 64 ࠭)
Dbs_File    DB_File  ( "test3.dbs" ); // 䠩   ࠡ⠥  
Dbs_F_Store DB_Store ( DB_File , DB_Cache ); // ࠭  䠩
Dbs_Store*  DB_List = &DB_Store; // ᯨ᮪ ࠭ ᯮ㥬  
Object_Database    Db( 1, &DB_List );   // ᮧ  

main () {
    Db.Open();  // 뢠  
    if( Db.Empty() )  { // ᫨  ,  㦭 ᮧ ୥ ꥪ
        char Buf[ 256 ];
        Tie<Record> Rec;
        while( fgets( Buf, sizeof Buf, stdin ) ) {
            Tie<Record> New = new (strlen(Buf)) Record; // ᮧ  
            if( !Nil(Rec) ) Rec->Next = New;
            strcpy( New->Text, Buf );
            Rec = New;
        }
	if (!Nil(Rec)) { 
	    Rec->Next = NULL;
	}
    } else { // ⮤ Start ୥ 㠫  ୥ ꥪ
        for(Ptr<Record> Rec = Ptr<Record>::Root(); !Nil(Rec); Rec = Rec->Next)
            fputs( Rec->Text, stdout );
    }
    Db.Close(); //     
    return 0;
}
